<?php require dirname(__FILE__)."/encryption.php";

    //数据排序并签名
    function getCompleData($json_arr){
        $data = getdata($json_arr);
        $hmacSource = getSorting($data);
        $hmac = getDataMac($hmacSource);
        $json_str = mergeData($hmac,$json_arr);
        return $json_str;
    }

    //获取加密后的请求数据
    function getmacdatas($json_str){
        $rands = getAESkey();
        $data = getCurlData($rands,$json_str);
        $encryptKey = getEncryptKey($rands);
        $requestdatas = array();
        $requestdatas["data"] = $data;
        $requestdatas["encryptKey"] = $encryptKey;
        return $requestdatas;
    }

    //返回数据解密后去掉hmac
    function responsegetdata($responseText){
        $responsedata = getresponsedata($responseText);
        $encryptkey = $responsedata['encryptkey'];
        $responsedatadata=$responsedata['data'];
        $screct_key = getDecryptAESKey($encryptkey);
        $encrypt_str = AESDecryptData($responsedatadata,$screct_key);
        $hmac = $encrypt_str['hmac'];
        unset($encrypt_str['hmac']); //去除数组的一个hmac元素
        ksort($encrypt_str);
        $datas = array();
        $datas["hmac"] = $hmac;
        $datas["encrypt_str"] = $encrypt_str;
        return $datas;
    }

    //数据验签
    function signatureVerification($datas){
        $hmac = $datas["hmac"];
        $encrypt_str = $datas["encrypt_str"];
        $hmacSource2 = getSorting($encrypt_str);
        $verify = dataVerify($hmacSource2,$hmac);
        return $verify;
    }

